;
;       TSR-PATCHer V. 2.1 beta
;       (gnarly bug-fixed ... public version)
;       fr CCC.GER Hacking Kurs by alx
;
;
	.model  tiny
	.code
	.startup
;        jmp     iii                    ; just 4 ASM-DEBUGGING
	jmp     install


;== Variablen =============================


; INDEX-Area ist wie folgt aufgebaut:
; 1 Byte SearchAnzahl
; 30 Bytes SearchString
; '##' als OWN-Kennung
; Patchbereich aus Offset-Word - 1 Byte PatchAnzahl - PatchValue
;
; und einer Endemarkierung, in diesem Fall 00h als PatchAnzahl

Index           db 'INDEX:'

SearchAnzahl    db 0
SearchArea      db 30 dup ('*')
PatchArea       db 200 dup (0)

TSRText1        db 'TSR-PATCHED at ',0
TSRText2        db 'Actual PSP at Segment ',0
Value           db '0123456789ABCDEF'
ConvertedReg    db 5 dup (0)
CursorPos       dw 0
bs_seg          dw      0b000h

;
INTactive       db 30 dup (0)


;== INT05 - Interrupt-Routine =====================
Kennung         db      "TSR-PAT"
neuint  proc    far
iii:
	;-- Init --
	push    ds
	push    es
	push    ax
	push    bx
	push    cx
	push    dx
	push    di
	push    bp

	push    cs
	pop     ds                              ; DS = CS

	jmp     short No_PSP
	; ^diesen JUMP raushauen, wenn TSR-PAT das PSP des Programms anzeigen
	; soll, von dem aus der Hotkey bettigt wurde ...

	; PSP des aktuellen Programms anzeigen
	mov     si,Offset TSRText2              ; Ausgabe PSP-Text
	mov     ah,07
	Call    WriteString

	mov     ax,6200h                        ; hole PSP-Adresse
	int     21h

	mov     ax,bx                           ; Segment anzeigen
	call    Reg2Str
	mov     si,Offset ConvertedReg
	mov     ah,70h
	call    WriteString
	call    PrintReturn                     ; in nchste Zeile wechseln

No_PSP:
	xor     ax,ax                           ; gesucht wird ab ES:DI
	mov     es,ax                           ; Init: ES=0000, DI=0000
	xor     di,di

	mov     bp,Offset SearchArea            ; Suchstr an DS:BP
	Call    SearchMemory
	mov     ax,es
	cmp     ax,0000h                        ; gefunden?
	je      RealEnde                        ; Nope!

	Call    PatchIt

RealEnde:
	;-- Register herstellen --
	pop     bp
	pop     di
	pop     dx
	pop     cx
	pop     bx
	pop     ax
	pop     es
	pop     ds
	;int 20h                        ; Just 4 debugging sessions ...
	iret
neuint  endp


;
SearchMemory    proc
; durchsucht solange ab ES:DI den Speicher, bis der in DS:BP angegebene
; Bereich gefunden wurde oder die ganzen 640K durchsucht wurden
; bei erfolgreichem Aufspren wird in ES:DI auf den Bereich gezeigt
; in SearchAnzahl steht die Anzahl der zu suchenden Bytes

        push    ax
	push    cx
	push    bx

SearchLoop:
	push    es                              ; SuchSegment nach AX
	pop     ax
	cmp     ax,0fbfeh                       ; gesamten Speicher durchsucht?
	jb      GoOn                            ; Nein, dann weitersuchen
	xor     ax,ax                           ; clear ES
	mov     es,ax
	jmp     short SearchMemoryEnde          ; Ja, dann Ende

GoOn:
	cld
	mov     cx,04000h                        ; in 64K-Blcken suchen
	sub     cx,di                           ; Startoffset abziehen
	mov     ax,ds:[bp]                      ; nach AX das 1. SuchWORD
scax:
	inc     di
	cmp     ax,es:[di]                      ; Finde WordMatch
	je      CompareSecond
	loop    scax
	cmp     cx,0                            ; was gefunden?
	jne     CompareSecond                   ; Ja, dann weitervergleichen
AddSegLoop:
	mov     ax,es                           ; Nein, dann Segment erhhen
	add     ax,0400h
	mov     es,ax
	xor     di,di                           ; Offset auf Null setzen

IncNLoop:
	;call    MakeSegment
	jmp     SearchLoop

CompareSecond:

	call    MakeSegment
	xor     ch,ch
	mov     cl,SearchAnzahl                 ; Anzahl der Suchbytes
	sub     cl,2

Looper2:
	mov     bx,cx
        add     bx,bp
	mov     al,ds:[bx+1]
	mov     bx,di
	sub     bx,1
	add     bx,cx
	cmp     al,es:[bx+2]
	jne     IncNLoop
	loop    Looper2

	; Vergleiche ob Suchstring ...
	xor     bh,bh
	mov     bl,SearchAnzahl
	mov     ax,es:[di+bx]
	cmp     ax,'##'
	je      IncNLoop                        ; Ja eigene Programmarea
						; also weitersuchen
SearchMemoryEnde:
	pop     bx
	pop     cx
        pop     ax
	ret
SearchMemory    endp

;
PatchIt         Proc
Patch:
	Call    MakeSegment

	; so, ab ES:DI luft nun mein neues Offset
	; nach CX kommt immer die Anzahl der zu patchenden Bytes
	; nach DL das zu patchende Word
	; nach BP kommt das zu addierende Offset
	; in SI steht die aktuelle Positin in der PatchArea
	; DH ist der Patchzhler

	cmp     PatchArea[si+2],00              ; Lnge 0 ??
	je      Ende                            ; Jau, also Ende
	xor     si,si                           ; Startposition
MultiPatch:
	xor     dh,dh                           ; ByteCount = 0
	mov     bp,word ptr PatchArea[si]
	add     si,2
	xor     ch,ch
	mov     cl,PatchArea[si]
	inc     si

PatchLoop:
	mov     dl,PatchArea[si]
	mov     bx,di
	add     bl,dh
	add     bx,bp
	mov     es:[bx],dl                      ; PATCHEN
	inc     si
	inc     dh
	Loop    PatchLoop

	call    OutSegOfs
	cmp     PatchArea[si+2],00              ; Lnge 0 ??
	je      Ende                            ; Jau, also Ende
	jmp     MultiPatch                      ; ansonsten weiterPATCHEN

Ende:
	Call    Beep
        ret
PatchIt         endp


;
MakeSegment     proc
	; Segment:Offset (ES:DI) normieren

	push    ax
	push    bx

	mov     ax,di                           ; Offset AX
	shr     ax,1                            ; Make Segment
	shr     ax,1
	shr     ax,1
	shr     ax,1
	mov     bx,es
	add     bx,ax                           ; Add to Segment
	mov     es,bx
	and     di,0fh                          ; Cut Offset

	pop     bx
	pop     ax
	ret
MakeSegment     endp

;
Beep    proc
	; Output a BEEEP through speaker
	push    ax
	push    cx

	mov     al, 0B6h                ; Timer Chip 2 Init
	out     43h, al
	mov     ax, 0A97h               ; 440 HZ
	out     42h, al                 ; Low byte of count to timer
	mov     al, ah
	out     42h, al                 ; High byte of count to timer
	in      al, 61h
	or      al, 3                   ; Set first two bits
	out     61h, al                 ; Turn speaker on

	mov     cx,0ffffh
pause:  mov     ax,es:[0]
	loop    pause
	in      al, 61h
	xor     al, 3                   ; Kill bits 0-1 to turn
	out     61h, al                 ;   speaker off

	pop     cx
	pop     ax
	ret
Beep    endp


;
OutSegOfs       proc
; Schreibt das Segment und Offset der gepatchten Area auf Herc.-Moni
	push    si
	push    ds
	push    ax
	push    es

	push    cs
	pop     ds

	mov     si,Offset TSRText1
	mov     ah,07
	Call    WriteString

	pop     es
	mov     ax,es                   ; Segment anzeigen
	call    Reg2Str
	mov     si,Offset ConvertedReg
	mov     ah,70h
	call    WriteString

	mov     ax,703Ah                ; ':'
	call    OutChar

	mov     ax,di                    ; Offset anzeigen
	add     ax,bp
	call    Reg2Str
	mov     si,Offset ConvertedReg
	mov     ah,70h
	call    WriteString

	call    PrintReturn             ; in nchste Zeile wechseln

	pop     ax
	pop     ds
	pop     si
	ret
OutSegOfs       endp

;
Reg2Str         proc
; kopiert Registerwerte in ConvertedReg-String
; in AX steht das zu konvertierende Register
	push    bx
	push    ax

	xor     bx,bx
					; Xxxx konvertieren
	shr     ah,1
	shr     ah,1
	shr     ah,1
	shr     ah,1
	mov     bl,ah
	mov     al,cs:Value[bx]
	mov     cs:ConvertedReg[0],al

	pop     ax
	push    ax
					 ; xXxx konvertieren
	and     ah,0Fh
	mov     bl,ah
	mov     al,cs:Value[bx]
	mov     cs:ConvertedReg[1],al

	pop     ax
	push    ax
					 ; xxXx konvertieren
	shr     al,1
	shr     al,1
	shr     al,1
	shr     al,1
	mov     bl,al
	mov     al,cs:Value[bx]
	mov     cs:ConvertedReg[2],al

	pop     ax
	push    ax
					; xxxX konvertieren
	and     al,0Fh
	mov     bl,al
	mov     al,cs:Value[bx]
	mov     cs:ConvertedReg[3],al

	pop     ax
	pop     bx
	ret
Reg2Str         endp

;
WriteString proc
; ## DS:SI - Adresse des Strings geterminated mit 0h
;    AH - Attributbyte
	push    ax
@@:
	lodsb
	cmp     al,0h
	jz      WS_Ende
	call    OutChar
	jmp     short @B
WS_Ende:
	pop     ax
	ret
WriteString endp

;
PrintReturn     proc
	; Erhht die CursorPos, sozusagen ein Zeilenvorschub
	push    ax
	push    bx
	mov     ax,CursorPos
	mov     bx,160
	div     bl
	mul     bl
	mov     bx,CursorPos
	sub     bx,ax
	sub     CursorPos,bx
	add     CursorPos,160
	pop     bx
	pop     ax
	ret
PrintReturn     endp

;
OutChar Proc
; Gibt ein Zeichen auf dem BS aus, bei rechts unten Umbruch auf links oben
; Zeichen in AL, Attribut in AH, aktuelle Adresse in Variable CursorPos
	push    es
	push    ds
	push    di
	push    cs
	pop     ds
	mov     dx,bs_seg                   ; Bildschirmspeicher
	mov     es,dx
	mov     di,ds:CursorPos
	add     CursorPos,2
	cmp     CursorPos,160*25
	jb      ff1
	mov     CursorPos,0
	mov     cx,4000
	xor     ax,ax
L:
	mov     bx,cx
	mov     es:[bx],ax
	loop    L
ff1:
	cmp     al,255                  ; 255 gibt nur Attributbyte aus!
	jne     @F
	inc     di
	mov     es:[di],ah
	jmp     short end_outchar
@@:
	stosw
end_outchar:
	pop     di
	pop     ds
	pop     es
	ret
OutChar endp

;== Daten (knnen berschrieben werden) ===

text1   db      10,10,13,"TSRPatch V2.1 -- 1995 "
	db      "von Alexander Gaupp",10,13
	db      "Aktivieren mit <Druck> bz"
	db      "w. <PrtScr>.",10,10,13,"$"
text2   db      10,10,13,"TSRPatch schon ge"
	db      "laden. Use /D to load anyway ...",10,10,13,"$"
install:
	; Clear Herkules-Screen
	mov     ax,bs_seg
	mov     es,ax
	mov     cx,4000
	xor     ax,ax
@@:
	mov     bx,cx
	mov     es:[bx],ax
	loop    @B

	; Ovverride Install-Check ?
	mov     ax,ds:[82h]
	cmp     ah,'D'
	je      MakeTSR
	cmp     ah,'d'
	je      MakeTSR


	;-- Vektor lesen --
	mov     ax,3505h
	int     21h
	;-- schon installiert? --
	cld
	mov     si,offset kennung
	sub     bx,7
	mov     di,bx
	mov     cx,7
	repe    cmpsb
	je      schon_da
MakeTSR:
	;-- Vektor setzen --
	mov     ax,2505h
	mov     dx,offset neuint
	int     21h
	;-- Meldung ausgeben --
	mov     ah,9
	mov     dx,offset text1
	int     21h
	;-- resident beenden --
	inc     dx
	int     27h
schon_da:
	;-- Fehlermeldung, Ende --
	mov     ah,9
	mov     dx,offset text2
	int     21h
	.exit   0
	end
